module sltt_const
  !
  != セミラグランジュ法 で用いる定数
  !
  != Constants for Semi-Lagrangian method
  !

  ! 種別型パラメタ
  ! Kind type parameter
  !
  use dc_types, only: DP    ! 倍精度実数型. Double precision.

  ! メッセージ出力
  ! Message output
  !
  use dc_message, only: MessageNotify


  ! 宣言文 ; Declaration statements
  !
  implicit none
  private

  ! 公開手続き
  ! Public procedure
  !
  public :: SLTTConstInit


  ! 公開変数
  ! Public variables
  !
  public :: jew !, dtjw
  public :: Pix2, PIH
  public :: nloop_dp_h, nloop_dp_v


  !
  ! local variables
  !
  !
  ! jew : latitudinal edge width
  !     : jew >= 4 and dtjw (dtjw is defined below)
  !     : In the current version of implimented semi-Lagrangian scheme, 
  !     : the lower limit of jew is 4, which is restricted by the number of
  !     : latitudinal grids needed to estimate values at poles. 
  !
  integer, parameter         :: jew = 4
  !
!!$  ! dtjw : data transfer latitudinal grid width
!!$  !      : int( C * 2 ) + 3 <= mpjwidth <= jmax and jew
!!$  !      : The mpjwidth must be less than jmax and jew, which is defined 
!!$  !      : above.
!!$  !      : The lower limit of mpjwidth is 3, if the Courant number is
!!$  !      :                      less than 0.5. 
!!$  !      : The lower limit of mpjwidth is 4, if the Courant number is
!!$  !      : greater than 0.5 and less than 1. 
!!$  !      : The lower limit of mpjwidth is 5, if the Courant number is
!!$  !      : greater than 1   and less than 1.5. 
!!$  !      : (But now, if the Courant number is greater than 0.5, this 
!!$  !      : routine would stop in sltt_dp_h and sltt_hiq routines.)
!!$  !
!!$  integer, parameter         :: dtjw = 3

  real(DP), save             :: PIx2, PIH


  integer, save              :: nloop_dp_h = 4
  integer, save              :: nloop_dp_v = 4


  ! 非公開変数
  ! Private variables
  !
  logical, save :: sltt_const_inited = .false.
                              ! 初期設定フラグ.
                              ! Initialization flag



  character(*), parameter:: module_name = 'sltt_const'
                              ! モジュールの名称.
                              ! Module name
  character(*), parameter:: version = &
    & '$Name:  $' // &
    & '$Id: vdiffusion_my1974.f90,v 1.30 2011-09-10 16:25:37 yot Exp $'
                              ! モジュールのバージョン
                              ! Module version


  !--------------------------------------------------------------------------------------

contains

  !--------------------------------------------------------------------------------------

  subroutine SLTTConstInit

    use gridset    , only : jmax
    use mpi_wrapper, only : nprocs, myrank
    use constants0 , only : PI


    !
    ! local variables
    !

    ! 実行文 ; Executable statement
    !

    if ( sltt_const_inited ) return


    PIx2 = PI + PI
    PIH  = PI / 2.0_DP


    if( jew > jmax/2 ) then
      write( 6, * ) "SLTT ERROR : MYRANK = ", myrank, &
        " JEW = ", jew, " JMAX/2 = ", jmax/2
      write( 6, * ) "SLTT ERROR : JEW MUST BE LESS THAN JMAX."
      stop
    end if
    if( nprocs > 1 ) then
!!$      if( jmax/2 < dtjw ) then
      if( jmax/2 < jew ) then
        write( 6, * ) "SLTT ERROR : MYRANK = ", myrank, &
!!$          " JMAX/2 = ", jmax/2, " TRANSFERED J WIDTH = ", dtjw
          " JMAX/2 = ", jmax/2, " TRANSFERED J WIDTH = ", jew
        write( 6, * ) "SLTT ERROR : JMAX MUST BE GREATER THAN TRANSFERED J WIDTH."
        stop
      end if
    end if


    sltt_const_inited = .true.

  end subroutine SLTTConstInit

  !--------------------------------------------------------------------------------------

end module sltt_const
